import { InstanceService } from '@/services/InstanceService';
import Store from '@/store';
import { DialogServiceCustom } from '@/services/DialogServiceCustom';
import { TekRestDatasource } from '@zeedhi/teknisa-components-common';
import { LoadingService } from '@zeedhi/common';
import { Http } from '@zeedhi/core';
import { AlertServiceCustom } from '@/services/AlertServiceCustom';

export class DMAddIssueController {
	private userAuth: any;

	public CDCLIENTE: any;

	public PRODUCT_VERSION: any;

	public async onMountedFormAddCallI() {
		const reportedByAddField = InstanceService.getInstanceZdSelect('reportedByAddI');
		this.userAuth = Store.getters['User/getUser'];
		await reportedByAddField.setValue(this.userAuth.CDOPERADOR, false);
	}

	public async onChangeScreenNameAddCallModal(params: any) {
		const versionIInstance = InstanceService.getInstanceZdSelect('versionAddI');
		if (params.component.value) {
			this.PRODUCT_VERSION = params.component.value.NREXTERNAL_PRODUCT_ID;
			try {
				await versionIInstance.datasource.get();
			} catch (e) {
				DialogServiceCustom.showErrorBackend(e);
			}
		}
	}

	public async onChangeClientAddCallModal(params: any) {
		const screenNameInstance = InstanceService.getInstanceSelectTree('screenNameAddI');
		screenNameInstance.nodes = [];
		if (params.value) {
			this.CDCLIENTE = params.value;
			if (screenNameInstance.datasource instanceof TekRestDatasource && screenNameInstance.datasource.filter.PRODUCT_ID) {
				try {
					await screenNameInstance.datasource.get();
					screenNameInstance.disabled = false;
				} catch (e) {
					DialogServiceCustom.showErrorBackend(e);
				}
			} else {
				screenNameInstance.disabled = true;
			}
		} else {
			screenNameInstance.disabled = true;
		}
	}

	public async saveAddIssue() { // SAVE
		const addCallFormInstance = InstanceService.getInstanceZdForm('formAddCallI');
		const checkValidation = addCallFormInstance.validate();
		if (checkValidation) {
			const callGridInstance = InstanceService.getInstanceTekGrid('gridDemandManagement');
			LoadingService.show();
				try {
					await Http.post('/productCallSave', {
						REFERENCE: addCallFormInstance.value.referenceAddI,
						CALL_LABELS: addCallFormInstance.value.labelsAddI,
						DESCRIPTION: addCallFormInstance.value.descriptionAddI,
						REPORTED_BY: addCallFormInstance.value.reportedByAddI,
						CDCLIENTE: addCallFormInstance.value.customerAddI,
						PLATAFORMA: 'MOBILE',
						PROJECT_ID: addCallFormInstance.value.productCodeAddI,
						SGSISTEMA: null,
						TYPE: 'I',
						PRODUCT_VERSION: '0',
						PRODUCT_RELEASE: '0',
						MENU_ITEM_ID: addCallFormInstance.value.screenNameAddI?.ID,
						BOARD: addCallFormInstance.value.productAddI?.PROJECT_ID,
						MENU_VERSION_ID: addCallFormInstance.value.versionAddI,
						CLASSIFICATION: addCallFormInstance.value.categoryAddI,
						APPOINTMENT_DATE: addCallFormInstance.value.appointmentDateAddI,
					});
					AlertServiceCustom.defaultSaveSuccessAlert();
					const cancelAddButtonS = InstanceService.getInstanceAny('cancelAddButtonI');
					cancelAddButtonS.events.click();
					await callGridInstance.datasource.get();
				} catch (e) {
					DialogServiceCustom.showErrorBackend(e);
				}
			LoadingService.hide();
		}
	}
}
